<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.12"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>eduRayTracer: Mat Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">eduRayTracer
   &#160;<span id="projectnumber">v_2017_2018_1</span>
   </div>
   <div id="projectbrief">An Educational Ray Tracing Software Package (by Pedro Santana, ISCTE-IUL)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.12 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('class_mat.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="#pub-attribs">Public Attributes</a> &#124;
<a href="class_mat-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Mat Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>A class to create and manipulate matrices.  
 <a href="class_mat.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_mat_8hpp_source.html">Mat.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:a81e79dbc41eec4017d02700a3e2e160b"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_mat.html#a81e79dbc41eec4017d02700a3e2e160b">Init</a> { <a class="el" href="class_mat.html#a81e79dbc41eec4017d02700a3e2e160ba43a34a635de69cc32c8a2521662a713d">ONES</a>, 
<a class="el" href="class_mat.html#a81e79dbc41eec4017d02700a3e2e160baae6ef16e75f48a8dd715cc491af9dc50">ZEROS</a>, 
<a class="el" href="class_mat.html#a81e79dbc41eec4017d02700a3e2e160ba66db4bfeb8c8fb32a2f397a965be7a21">EYE</a>
 }<tr class="memdesc:a81e79dbc41eec4017d02700a3e2e160b"><td class="mdescLeft">&#160;</td><td class="mdescRight">labels for creating patterned matrices  <a href="class_mat.html#a81e79dbc41eec4017d02700a3e2e160b">More...</a><br /></td></tr>
</td></tr>
<tr class="separator:a81e79dbc41eec4017d02700a3e2e160b"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a7205342eec3270c1aa954f35d8af27c7"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_mat.html#a7205342eec3270c1aa954f35d8af27c7">Mat</a> ()</td></tr>
<tr class="memdesc:a7205342eec3270c1aa954f35d8af27c7"><td class="mdescLeft">&#160;</td><td class="mdescRight">A <a class="el" href="class_mat.html" title="A class to create and manipulate matrices. ">Mat</a> constructor with all matrix elements set to 0.  <a href="#a7205342eec3270c1aa954f35d8af27c7">More...</a><br /></td></tr>
<tr class="separator:a7205342eec3270c1aa954f35d8af27c7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8ade1cac47d130a334e4e800d1111875"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_mat.html#a8ade1cac47d130a334e4e800d1111875">Mat</a> (<a class="el" href="class_mat.html#a81e79dbc41eec4017d02700a3e2e160b">Init</a> t)</td></tr>
<tr class="memdesc:a8ade1cac47d130a334e4e800d1111875"><td class="mdescLeft">&#160;</td><td class="mdescRight">A <a class="el" href="class_mat.html" title="A class to create and manipulate matrices. ">Mat</a> constructor with matrix elements initialised according to an Init label.  <a href="#a8ade1cac47d130a334e4e800d1111875">More...</a><br /></td></tr>
<tr class="separator:a8ade1cac47d130a334e4e800d1111875"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1e30e252a1e556ac5e131edac7b08a23"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_mat.html#a1e30e252a1e556ac5e131edac7b08a23">Mat</a> (const <a class="el" href="class_mat.html">Mat</a> &amp;m)</td></tr>
<tr class="memdesc:a1e30e252a1e556ac5e131edac7b08a23"><td class="mdescLeft">&#160;</td><td class="mdescRight">A <a class="el" href="class_mat.html" title="A class to create and manipulate matrices. ">Mat</a> constructor with matrix elements initialised according to a given matrix.  <a href="#a1e30e252a1e556ac5e131edac7b08a23">More...</a><br /></td></tr>
<tr class="separator:a1e30e252a1e556ac5e131edac7b08a23"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9bc6ed47532e2ce5174aac9c80a20ba4"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_mat.html#a9bc6ed47532e2ce5174aac9c80a20ba4">Mat</a> (const double m[4][4])</td></tr>
<tr class="memdesc:a9bc6ed47532e2ce5174aac9c80a20ba4"><td class="mdescLeft">&#160;</td><td class="mdescRight">A <a class="el" href="class_mat.html" title="A class to create and manipulate matrices. ">Mat</a> constructor with matrix elements initialised according to a given data array.  <a href="#a9bc6ed47532e2ce5174aac9c80a20ba4">More...</a><br /></td></tr>
<tr class="separator:a9bc6ed47532e2ce5174aac9c80a20ba4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2d0c8183b215b55d6d7d6de2cd099c23"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_mat.html">Mat</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_mat.html#a2d0c8183b215b55d6d7d6de2cd099c23">operator=</a> (const <a class="el" href="class_mat.html">Mat</a> &amp;m)</td></tr>
<tr class="memdesc:a2d0c8183b215b55d6d7d6de2cd099c23"><td class="mdescLeft">&#160;</td><td class="mdescRight">Copies the contents of a given matrix to this matrix (assignment operator)  <a href="#a2d0c8183b215b55d6d7d6de2cd099c23">More...</a><br /></td></tr>
<tr class="separator:a2d0c8183b215b55d6d7d6de2cd099c23"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a16c420cd1147660064644876769f6c32"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_mat.html">Mat</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_mat.html#a16c420cd1147660064644876769f6c32">operator+</a> (const <a class="el" href="class_mat.html">Mat</a> &amp;m)</td></tr>
<tr class="memdesc:a16c420cd1147660064644876769f6c32"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a matrix resulting from adding a given matrix to this matrix.  <a href="#a16c420cd1147660064644876769f6c32">More...</a><br /></td></tr>
<tr class="separator:a16c420cd1147660064644876769f6c32"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac55ba72ef5aca0073b943f474a52cd00"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_mat.html">Mat</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_mat.html#ac55ba72ef5aca0073b943f474a52cd00">operator*</a> (const <a class="el" href="class_mat.html">Mat</a> &amp;m)</td></tr>
<tr class="memdesc:ac55ba72ef5aca0073b943f474a52cd00"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a matrix resulting from multiplying this matrix to another given matrix (proper matrix dimensions must be handled by the user)  <a href="#ac55ba72ef5aca0073b943f474a52cd00">More...</a><br /></td></tr>
<tr class="separator:ac55ba72ef5aca0073b943f474a52cd00"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a56c56f48688e75ebee6f2bae71b3b978"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_vec.html">Vec</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_mat.html#a56c56f48688e75ebee6f2bae71b3b978">operator*</a> (const <a class="el" href="class_vec.html">Vec</a> &amp;v)</td></tr>
<tr class="memdesc:a56c56f48688e75ebee6f2bae71b3b978"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a matrix resulting from multiplying this matrix to a given vector (proper matrix and vector dimensions must be handled by the user)  <a href="#a56c56f48688e75ebee6f2bae71b3b978">More...</a><br /></td></tr>
<tr class="separator:a56c56f48688e75ebee6f2bae71b3b978"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a55e6cc33fc65042a4cff351fe59ae476"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_mat.html">Mat</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_mat.html#a55e6cc33fc65042a4cff351fe59ae476">transpose</a> ()</td></tr>
<tr class="memdesc:a55e6cc33fc65042a4cff351fe59ae476"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the transpose of this matrix.  <a href="#a55e6cc33fc65042a4cff351fe59ae476">More...</a><br /></td></tr>
<tr class="separator:a55e6cc33fc65042a4cff351fe59ae476"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aff86e230a7fdd2e204fc5e19dfce6b5c"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_mat.html">Mat</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_mat.html#aff86e230a7fdd2e204fc5e19dfce6b5c">invert</a> ()</td></tr>
<tr class="memdesc:aff86e230a7fdd2e204fc5e19dfce6b5c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the inverted version of this matrix.  <a href="#aff86e230a7fdd2e204fc5e19dfce6b5c">More...</a><br /></td></tr>
<tr class="separator:aff86e230a7fdd2e204fc5e19dfce6b5c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab44133772f822f6963924b1a6e94290a"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_mat.html#ab44133772f822f6963924b1a6e94290a">print</a> ()</td></tr>
<tr class="memdesc:ab44133772f822f6963924b1a6e94290a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sends to the std::out information regarding this matrix.  <a href="#ab44133772f822f6963924b1a6e94290a">More...</a><br /></td></tr>
<tr class="separator:ab44133772f822f6963924b1a6e94290a"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:a0c3c288d54e1da52cfdc6282957518aa"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="class_mat.html">Mat</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_mat.html#a0c3c288d54e1da52cfdc6282957518aa">LookAt</a> (<a class="el" href="class_vec.html">Vec</a> e, <a class="el" href="class_vec.html">Vec</a> a, <a class="el" href="class_vec.html">Vec</a> up)</td></tr>
<tr class="memdesc:a0c3c288d54e1da52cfdc6282957518aa"><td class="mdescLeft">&#160;</td><td class="mdescRight">A <a class="el" href="class_mat.html" title="A class to create and manipulate matrices. ">Mat</a> constructor with matrix elements initialised according to eye-gaze-up convention.  <a href="#a0c3c288d54e1da52cfdc6282957518aa">More...</a><br /></td></tr>
<tr class="separator:a0c3c288d54e1da52cfdc6282957518aa"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae8d389f834ae11fb758070887558be4f"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="class_mat.html">Mat</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_mat.html#ae8d389f834ae11fb758070887558be4f">RotX</a> (double _angle)</td></tr>
<tr class="memdesc:ae8d389f834ae11fb758070887558be4f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a <a class="el" href="class_mat.html" title="A class to create and manipulate matrices. ">Mat</a> with its matrix elements initialised so as to implement a rotation around the x-axis.  <a href="#ae8d389f834ae11fb758070887558be4f">More...</a><br /></td></tr>
<tr class="separator:ae8d389f834ae11fb758070887558be4f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad26724c51d7d57072a9a3462bf397059"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="class_mat.html">Mat</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_mat.html#ad26724c51d7d57072a9a3462bf397059">RotY</a> (double _angle)</td></tr>
<tr class="memdesc:ad26724c51d7d57072a9a3462bf397059"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a <a class="el" href="class_mat.html" title="A class to create and manipulate matrices. ">Mat</a> with its matrix elements initialised so as to implement a rotation around the y-axis.  <a href="#ad26724c51d7d57072a9a3462bf397059">More...</a><br /></td></tr>
<tr class="separator:ad26724c51d7d57072a9a3462bf397059"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a34ea7b2e8ecae17538e7acd01aa58cc4"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="class_mat.html">Mat</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_mat.html#a34ea7b2e8ecae17538e7acd01aa58cc4">RotZ</a> (double _angle)</td></tr>
<tr class="memdesc:a34ea7b2e8ecae17538e7acd01aa58cc4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a <a class="el" href="class_mat.html" title="A class to create and manipulate matrices. ">Mat</a> with its matrix elements initialised so as to implement a rotation around the z-axis.  <a href="#a34ea7b2e8ecae17538e7acd01aa58cc4">More...</a><br /></td></tr>
<tr class="separator:a34ea7b2e8ecae17538e7acd01aa58cc4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a859787d27737801fd4eb282c2a0f3b3d"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="class_mat.html">Mat</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_mat.html#a859787d27737801fd4eb282c2a0f3b3d">Scale</a> (double _sx, double _sy, double _sz)</td></tr>
<tr class="memdesc:a859787d27737801fd4eb282c2a0f3b3d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a <a class="el" href="class_mat.html" title="A class to create and manipulate matrices. ">Mat</a> with its matrix elements initialised so as to implement a non-uniform scaling.  <a href="#a859787d27737801fd4eb282c2a0f3b3d">More...</a><br /></td></tr>
<tr class="separator:a859787d27737801fd4eb282c2a0f3b3d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a274248708a0553b5edaabbab255afdcb"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="class_mat.html">Mat</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_mat.html#a274248708a0553b5edaabbab255afdcb">Translate</a> (double _tx, double _ty, double _tz)</td></tr>
<tr class="memdesc:a274248708a0553b5edaabbab255afdcb"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a <a class="el" href="class_mat.html" title="A class to create and manipulate matrices. ">Mat</a> with its matrix elements initialised so as to implement a translation.  <a href="#a274248708a0553b5edaabbab255afdcb">More...</a><br /></td></tr>
<tr class="separator:a274248708a0553b5edaabbab255afdcb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acb41436cda0e8494d41cb888458ad791"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="class_mat.html">Mat</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_mat.html#acb41436cda0e8494d41cb888458ad791">FullPose</a> (double yaw, double pitch, double roll, double dx, double dy, double dz, double scale_x, double scale_y, double scale_z)</td></tr>
<tr class="separator:acb41436cda0e8494d41cb888458ad791"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr class="memitem:aaefe5fd9b60dd6722fde62ef17471251"><td class="memItemLeft" align="right" valign="top">double&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_mat.html#aaefe5fd9b60dd6722fde62ef17471251">data</a> [4][4]</td></tr>
<tr class="memdesc:aaefe5fd9b60dd6722fde62ef17471251"><td class="mdescLeft">&#160;</td><td class="mdescRight">array containing the matrix data  <a href="#aaefe5fd9b60dd6722fde62ef17471251">More...</a><br /></td></tr>
<tr class="separator:aaefe5fd9b60dd6722fde62ef17471251"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>A class to create and manipulate matrices. </p>
</div><h2 class="groupheader">Member Enumeration Documentation</h2>
<a id="a81e79dbc41eec4017d02700a3e2e160b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a81e79dbc41eec4017d02700a3e2e160b">&sect;&nbsp;</a></span>Init</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="class_mat.html#a81e79dbc41eec4017d02700a3e2e160b">Mat::Init</a></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>labels for creating patterned matrices </p>
<table class="fieldtable">
<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="a81e79dbc41eec4017d02700a3e2e160ba43a34a635de69cc32c8a2521662a713d"></a>ONES&#160;</td><td class="fielddoc"><p>Identity matrix </p>
</td></tr>
<tr><td class="fieldname"><a id="a81e79dbc41eec4017d02700a3e2e160baae6ef16e75f48a8dd715cc491af9dc50"></a>ZEROS&#160;</td><td class="fielddoc"><p>Matrix filled with 0s </p>
</td></tr>
<tr><td class="fieldname"><a id="a81e79dbc41eec4017d02700a3e2e160ba66db4bfeb8c8fb32a2f397a965be7a21"></a>EYE&#160;</td><td class="fielddoc"><p>Matrix filled with 1s </p>
</td></tr>
</table>

</div>
</div>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a7205342eec3270c1aa954f35d8af27c7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7205342eec3270c1aa954f35d8af27c7">&sect;&nbsp;</a></span>Mat() <span class="overload">[1/4]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Mat::Mat </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>A <a class="el" href="class_mat.html" title="A class to create and manipulate matrices. ">Mat</a> constructor with all matrix elements set to 0. </p>

</div>
</div>
<a id="a8ade1cac47d130a334e4e800d1111875"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8ade1cac47d130a334e4e800d1111875">&sect;&nbsp;</a></span>Mat() <span class="overload">[2/4]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Mat::Mat </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_mat.html#a81e79dbc41eec4017d02700a3e2e160b">Init</a>&#160;</td>
          <td class="paramname"><em>t</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>A <a class="el" href="class_mat.html" title="A class to create and manipulate matrices. ">Mat</a> constructor with matrix elements initialised according to an Init label. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">t</td><td>Init label stating which kind of initialisation is desired </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a1e30e252a1e556ac5e131edac7b08a23"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1e30e252a1e556ac5e131edac7b08a23">&sect;&nbsp;</a></span>Mat() <span class="overload">[3/4]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Mat::Mat </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="class_mat.html">Mat</a> &amp;&#160;</td>
          <td class="paramname"><em>m</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>A <a class="el" href="class_mat.html" title="A class to create and manipulate matrices. ">Mat</a> constructor with matrix elements initialised according to a given matrix. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">m</td><td>Matrix used to initialise this matrix </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a9bc6ed47532e2ce5174aac9c80a20ba4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9bc6ed47532e2ce5174aac9c80a20ba4">&sect;&nbsp;</a></span>Mat() <span class="overload">[4/4]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Mat::Mat </td>
          <td>(</td>
          <td class="paramtype">const double&#160;</td>
          <td class="paramname"><em>m</em>[4][4]</td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>A <a class="el" href="class_mat.html" title="A class to create and manipulate matrices. ">Mat</a> constructor with matrix elements initialised according to a given data array. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">m</td><td>Data array used to initialise this matrix </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="acb41436cda0e8494d41cb888458ad791"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acb41436cda0e8494d41cb888458ad791">&sect;&nbsp;</a></span>FullPose()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_mat.html">Mat</a> Mat::FullPose </td>
          <td>(</td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>yaw</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>pitch</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>roll</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>dx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>dy</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>dz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>scale_x</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>scale_y</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>scale_z</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Returns a <a class="el" href="class_mat.html" title="A class to create and manipulate matrices. ">Mat</a> properly initialised from orientation, position data, and scale data. Orientation and position data is assumed to be read with co-moving axes. The order to transformations is as follows: displacement-&gt;yaw-&gt;pitch-&gt;roll-&gt;scale</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">yaw</td><td>Angle of rotation (in radians) around y-axis </td></tr>
    <tr><td class="paramname">pitch</td><td>Angle of rotation (in radians) around x-axis </td></tr>
    <tr><td class="paramname">roll</td><td>Angle of rotation (in radians) around z-axis </td></tr>
    <tr><td class="paramname">dx</td><td>Displacement along x-axis </td></tr>
    <tr><td class="paramname">dy</td><td>Displacement along y-axis </td></tr>
    <tr><td class="paramname">dz</td><td>Displacement along z-axis </td></tr>
    <tr><td class="paramname">scale_x</td><td>Scale along x-axis </td></tr>
    <tr><td class="paramname">scale_y</td><td>Scale along y-axis </td></tr>
    <tr><td class="paramname">scale_z</td><td>Scale along z-axis </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="aff86e230a7fdd2e204fc5e19dfce6b5c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aff86e230a7fdd2e204fc5e19dfce6b5c">&sect;&nbsp;</a></span>invert()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_mat.html">Mat</a> Mat::invert </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns the inverted version of this matrix. </p>

</div>
</div>
<a id="a0c3c288d54e1da52cfdc6282957518aa"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0c3c288d54e1da52cfdc6282957518aa">&sect;&nbsp;</a></span>LookAt()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_mat.html">Mat</a> Mat::LookAt </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_vec.html">Vec</a>&#160;</td>
          <td class="paramname"><em>e</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_vec.html">Vec</a>&#160;</td>
          <td class="paramname"><em>a</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="class_vec.html">Vec</a>&#160;</td>
          <td class="paramname"><em>up</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>A <a class="el" href="class_mat.html" title="A class to create and manipulate matrices. ">Mat</a> constructor with matrix elements initialised according to eye-gaze-up convention. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">e</td><td>Eye vector </td></tr>
    <tr><td class="paramname">a</td><td>'at' Vector </td></tr>
    <tr><td class="paramname">up</td><td>Up vector </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ac55ba72ef5aca0073b943f474a52cd00"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac55ba72ef5aca0073b943f474a52cd00">&sect;&nbsp;</a></span>operator*() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_mat.html">Mat</a> Mat::operator* </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="class_mat.html">Mat</a> &amp;&#160;</td>
          <td class="paramname"><em>m</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns a matrix resulting from multiplying this matrix to another given matrix (proper matrix dimensions must be handled by the user) </p>

</div>
</div>
<a id="a56c56f48688e75ebee6f2bae71b3b978"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a56c56f48688e75ebee6f2bae71b3b978">&sect;&nbsp;</a></span>operator*() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_vec.html">Vec</a> Mat::operator* </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="class_vec.html">Vec</a> &amp;&#160;</td>
          <td class="paramname"><em>v</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns a matrix resulting from multiplying this matrix to a given vector (proper matrix and vector dimensions must be handled by the user) </p>

</div>
</div>
<a id="a16c420cd1147660064644876769f6c32"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a16c420cd1147660064644876769f6c32">&sect;&nbsp;</a></span>operator+()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_mat.html">Mat</a> Mat::operator+ </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="class_mat.html">Mat</a> &amp;&#160;</td>
          <td class="paramname"><em>m</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns a matrix resulting from adding a given matrix to this matrix. </p>

</div>
</div>
<a id="a2d0c8183b215b55d6d7d6de2cd099c23"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2d0c8183b215b55d6d7d6de2cd099c23">&sect;&nbsp;</a></span>operator=()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_mat.html">Mat</a> Mat::operator= </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="class_mat.html">Mat</a> &amp;&#160;</td>
          <td class="paramname"><em>m</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Copies the contents of a given matrix to this matrix (assignment operator) </p>

</div>
</div>
<a id="ab44133772f822f6963924b1a6e94290a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab44133772f822f6963924b1a6e94290a">&sect;&nbsp;</a></span>print()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Mat::print </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Sends to the std::out information regarding this matrix. </p>

</div>
</div>
<a id="ae8d389f834ae11fb758070887558be4f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae8d389f834ae11fb758070887558be4f">&sect;&nbsp;</a></span>RotX()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_mat.html">Mat</a> Mat::RotX </td>
          <td>(</td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>_angle</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns a <a class="el" href="class_mat.html" title="A class to create and manipulate matrices. ">Mat</a> with its matrix elements initialised so as to implement a rotation around the x-axis. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_angle</td><td>Rotation angle in radians. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ad26724c51d7d57072a9a3462bf397059"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad26724c51d7d57072a9a3462bf397059">&sect;&nbsp;</a></span>RotY()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_mat.html">Mat</a> Mat::RotY </td>
          <td>(</td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>_angle</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns a <a class="el" href="class_mat.html" title="A class to create and manipulate matrices. ">Mat</a> with its matrix elements initialised so as to implement a rotation around the y-axis. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_angle</td><td>Rotation angle in radians. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a34ea7b2e8ecae17538e7acd01aa58cc4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a34ea7b2e8ecae17538e7acd01aa58cc4">&sect;&nbsp;</a></span>RotZ()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_mat.html">Mat</a> Mat::RotZ </td>
          <td>(</td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>_angle</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns a <a class="el" href="class_mat.html" title="A class to create and manipulate matrices. ">Mat</a> with its matrix elements initialised so as to implement a rotation around the z-axis. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_angle</td><td>Rotation angle in radians. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a859787d27737801fd4eb282c2a0f3b3d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a859787d27737801fd4eb282c2a0f3b3d">&sect;&nbsp;</a></span>Scale()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_mat.html">Mat</a> Mat::Scale </td>
          <td>(</td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>_sx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>_sy</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>_sz</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns a <a class="el" href="class_mat.html" title="A class to create and manipulate matrices. ">Mat</a> with its matrix elements initialised so as to implement a non-uniform scaling. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_sx</td><td>Scale factor along the x-axis. </td></tr>
    <tr><td class="paramname">_sy</td><td>Scale factor along the y-axis. </td></tr>
    <tr><td class="paramname">_sz</td><td>Scale factor along the z-axis. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a274248708a0553b5edaabbab255afdcb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a274248708a0553b5edaabbab255afdcb">&sect;&nbsp;</a></span>Translate()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_mat.html">Mat</a> Mat::Translate </td>
          <td>(</td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>_tx</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>_ty</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">double&#160;</td>
          <td class="paramname"><em>_tz</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Returns a <a class="el" href="class_mat.html" title="A class to create and manipulate matrices. ">Mat</a> with its matrix elements initialised so as to implement a translation. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">_tx</td><td>Translation amount along the x-axis. </td></tr>
    <tr><td class="paramname">_ty</td><td>Translation amount along the y-axis. </td></tr>
    <tr><td class="paramname">_tz</td><td>Translation amount along the z-axis. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a55e6cc33fc65042a4cff351fe59ae476"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a55e6cc33fc65042a4cff351fe59ae476">&sect;&nbsp;</a></span>transpose()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_mat.html">Mat</a> Mat::transpose </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Returns the transpose of this matrix. </p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="aaefe5fd9b60dd6722fde62ef17471251"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aaefe5fd9b60dd6722fde62ef17471251">&sect;&nbsp;</a></span>data</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">double Mat::data[4][4]</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>array containing the matrix data </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>src/<a class="el" href="_mat_8hpp_source.html">Mat.hpp</a></li>
<li>src/<a class="el" href="_mat_8cpp.html">Mat.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="class_mat.html">Mat</a></li>
    <li class="footer">Generated on Fri Sep 15 2017 15:54:23 for eduRayTracer by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.12 </li>
  </ul>
</div>
</body>
</html>
